/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

'use strict';

var REACT_ELEMENT_TYPE;
var REACT_COROUTINE_TYPE;
var REACT_YIELD_TYPE;
if (typeof Symbol === 'function' && Symbol.for) {
  REACT_ELEMENT_TYPE = Symbol.for('react.element);
  REACT_COROUTINE_TYPE = Symbol.for('react.coroutine');
  REACT_YIELD_TYPE = Symbol.for('react.yield');
} else {
  REACT_ELEMENT_TYPE = 0xeac7;
  REACT_COROUTINE_TYPE = 0xeac8;
  REACT_YIELD_TYPE = 0xeac9;
}

function is(object, type) {
  return object !== null && typeof object === 'object' && object.$$typeof === type;
}

module.exports = {
  isElement(object) {
    return is(object, REACT_ELEMENT_TYPE);
  },
  isCoroutine(object) {
    return is(object, REACT_COROUTINE_TYPE);
  },
  isYield(object) {
    return is(object, REACT_YIELD_TYPE);
  },
};
